sim.fun <- function(iter=1) {

### First run the original data ###


      Z_vec <- quantile(Z, c(0.1,0.25,0.5,0.75,0.9))

      ci <- Time-min(Time);si <- state+1;t <- max(ci)+2

	h <- dpik(ci,gridsize=m+1,range=c(0,10*max(ci)))
 
	a <- seq(t,10*t,length=10)		

	grid<-gc<-matrix(0,length(a),m)
	
	for (i in 1:length(a))
	{	
	 grid[i,]<- seq(0,a[i],length=m)
  	 gc[i,]  <- apply(outer(grid[i,],ci,Kh,h=h),1,mean)
      }

	Tmax <- grid[min(which(gc==0))-3]
        ifelse(Tmax < max(ci)+2,Tmax,max(ci)+2)

		fine_grid <- seq(from=0,to=Tmax,bin)  # time grid
		m_f <- length(fine_grid)
		h_t <- dpik(ci,gridsize=m+1,range=c(0,Tmax)) # common bandwidth 

		gc <- round(apply(outer(fine_grid,ci,Kh,h=h_t),1,mean),d=20)
		if (sum(which(gc==0)>0)) Tmax <- fine_grid[min(which(gc==0))-3]
	      fine_grid <- seq(from=0,to=Tmax,bin)  # time grid
	      h_t <- dpik(ci,gridsize=m+1,range=c(0,Tmax)) # common bandwidth, common variance

            M <- ID
            Z_1 <- rep(0,length(unique(M)))
            for (i in 1:length(unique(M))){
                                           Z_1[i] <-sample(Z[M==unique(M)[i]],1)
                                          }
            h_Z <- dpikSafe(Z_1,gridsize=length(ci))

              ### Original L1 distance ###

              #####################################
		  # weighted marginal
		  #####################################	
		  
		  
		   w1 <- dN(ci,si,Z=FALSE,Z_a=FALSE,size,ID,Tmax,h_t,h_Z)

		   ## The state occupation, entry and exit times distribution 
		   
		   temp1 <- PLE(ci,si,w1,t)

## Estimate L1 distances at each BMI quartile ##

 delta0.mat<- matrix(0,5,7)

 for (ii in 1:length(Z_vec)){

		  ######################################
		  # weighted with covariate X adjustment
		  ######################################  		  

		   w2 <- dN(ci,si,Z,Z_vec[ii],size,ID,Tmax,h_t,h_Z)

		   ## PLE 

		   temp2 <- PLE(ci,si,w2,t)
               
		   ##### Get the test statistics by applying grids of cis

		   #index1 <- apply(matrix(ci,length(ci),1),1,comp,y=temp1$grid[-m])


		   ##################################
		   #Test statistics from L1 distances
		   ##################################

		   delta0.mat[ii,] <- apply(abs(temp1$MAT-temp2$MAT),2,mean)

  }

## The original L1 distance for BMI ##
delta0 <- apply(delta0.mat,2,mean)

     
     
### Start bootstrap sampling and calculate L1 distances ###
     
delta_temp <- NULL #matrix(0,nsim,7)
     		
     
     
     
         ## Step 1: Naive bootstrap sample of cluster 1=<i=<M ni, ci and si
         M <- sample(unique(ID),r=T)
         num.cluster <- length(M)
     
         ID.M <- I.size <- NULL
         for (j in 1:num.cluster) { ID.M <- c(which(ID==M[j]),ID.M)
                                    I.size <- c(I.size,size[min(which(ID==M[j]))])
              }
         data_star <- data[ID.M,]
         ci_star <- data_star$Time - 13.5
         si_star <- data_star$state + 1 
         nid_star <- data_star$nid
         size_star <- data_star$n.clus.size
      
        ## Step 2: Naive bootstrap sample of cluster level variance
         M.x <- sample(unique(ID),r=T) # for independent sample of the covariate X
     
         Z.x <- NULL
         for (j in 1:num.cluster) {
            Z.x <- c(Z.x, Z[min(which(ID==M.x[j]))])
         }
     
         Z_star <- NULL
     
         for (q in 1:num.cluster ) { 
       
            Z_star <- c(Z_star,rep(Z.x[q],I.size[q]))
         }
     
     
         ## Step 3: Order the bootstrapped observations by ci_star ##
         
          Id1 <- order(ci_star)
     
          ci_star <-ci_star[Id1];si_star <- si_star[Id1];nid_star <-nid_star[Id1]
          size_star <- size_star[Id1]; Z_star <- Z_star[Id1]     
     
         ## Step 4: generate time limit for the bootstrapped sample ##
     
     
     	 h_star <- dpik(ci_star,gridsize=m+1,range=c(0,10*max(ci_star)))
      
     	 a_star <- seq(t,10*t,length=10)		
     
     	 grid_star<-gc_star<-matrix(0,length(a_star),m)
     	 for (i in 1:length(a_star))
     	{	
     	 grid_star[i,]<- seq(0,a_star[i],length=m)
       	 gc_star[i,]  <- apply(outer(grid_star[i,],ci_star,Kh,h=h),1,mean)
           }
     
     	Tmax_star <- grid_star[min(which(gc_star==0))-3]
             ifelse(min(which(gc_star==0))<500, Tmax_star <- max(ci_star),Tmax_star <- grid_star[min(which(gc_star==0))-3])
     	
             ifelse(Tmax_star < max(ci_star)+2,Tmax_star,max(ci_star)+2)
     
          ## Step 5: calculate the MAD_star at each value of BMI
     
                  # First get the weighted marginal estimation #
     	  	
     		   w1 <- dN(ci_star,si_star,Z=FALSE,Z_a=FALSE,size_star,nid_star,Tmax_star,h_t,h_Z)
     
     		   # The state occupation, entry and exit times distribution 
     		   temp1 <- PLE(ci_star,si_star,w1,t)
      
                  # Then obtain conditional estimation at each value of BMI #
      	
                    delta_temp.mat <- matrix(0,length(Z_vec),7)
     
      	         for (jj in 1:length(Z_vec)){
     
     		               w2 <- dN(ci_star,si_star,Z_star,Z_vec[jj],size_star,nid_star,Tmax_star,h_t,h_Z)
     		               temp2 <- PLE(ci_star,si_star,w2,t)
     
                                delta_temp.mat[jj,] <- apply(abs(temp1$MAT-temp2$MAT),2,mean)
     
       		               }
     
delta_temp <- apply(delta_temp.mat,2,mean)
c(delta0, delta_temp)

} 